// ------------------------------------
// Version 1.0 : Base de données NoSQL
// ------------------------------------

// Copyright (C) 2014 (Aridhi, Lacomme, Phan)

// Ce programme (ainsi que la bibliothèque objets livrée avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Générale GNU publiée par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultérieure choisie par vous).
// Ce programme est distribué car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spécifique. Reportez-vous à la
// Licence Publique Générale GNU pour plus de détails.
// Vous devez avoir reçu une copie de la Licence
// Publique Générale GNU en même temps que
// ce programme ; si ce n'est pas le cas, écrivez à la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, États-Unis.


package testjedis;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import redis.clients.jedis.*;

public class TestJedis {

    public static void main(String[] args) {
        Jedis jedis = new Jedis("localhost");
        /*
        jedis.set("Durant", "Mon premier roman");
        String value = jedis.get("Durant");
        System.out.println("value = "+value);*/

        /*
        jedis.rpush("message_java", "Bienvenue dans Redis");
        jedis.rpush("message_java", "Ceci est un chapitre introductif");
        jedis.rpush("message_java", "les exemples sont simples");

        List<String> value = jedis.lrange("message_java", 0, 2);
        for (int i = 0; i < value.size(); i++) {
            System.out.println("value numero " + i + " = " + value.get(i));
        }*/

        /*
        jedis.hset("mon_hash_java", "Durant", "mon premier_roman");
        jedis.hset("mon_hash_java", "Tintin", "un livre scientifique");
        jedis.hset("mon_hash_java", "Milou", "Etre le chien de");

        Map<String, String> une_map = jedis.hgetAll("mon_hash_java");

        Set listKeys = une_map.keySet();
        Iterator iterateur = listKeys.iterator();

        while (iterateur.hasNext()) {
            Object key = iterateur.next();
            System.out.println(key + "=>" + une_map.get(key));
        }*/

        /*
        jedis.sadd("roman_java", "tintin");
        jedis.sadd("roman_java", "durant");
        jedis.sadd("roman_java", "milou");

        jedis.sadd("BDD_java", "delisse");
        jedis.sadd("BDD_java", "manning");
        jedis.sadd("BDD_java", "Macedo");

        Set<String> tous_les_auteurs = jedis.sunion("roman_java", "BDD_java");

        Set<String> value_BDD = jedis.smembers("BDD_java");
        System.out.println("Auteurs de bandes dessinées = " + value_BDD);

        Set<String> value_roman = jedis.smembers("roman_java");
        System.out.println("Auteurs de roman = " + value_roman);

        System.out.println("Auteurs  = " + tous_les_auteurs);

        // affichage de l'ensemble des auteurs
        System.out.println("Affichage.... des auteurs");
        Iterator<String> it = tous_les_auteurs.iterator();
        int i = 1;
        while (it.hasNext()) {
            String Nom = (String) it.next();
            System.out.println("auteur numero " + i + " : " + Nom);
            i++;
        }*/
        

        jedis.zadd("livre_java", 60, "mon premier romain");
        jedis.zadd("livre_java", 10, "un livre scientifique");
        jedis.zadd("livre_java", 20, "etre le chien de");

        Set<String> value_livre_java = jedis.zrange("livre_java", 0, 3);
        System.out.println("liste de livres triés = " + value_livre_java);

        // affichage de l'ensemble des livres
        System.out.println("Affichage.... des livres");
        Iterator<String> it = value_livre_java.iterator();
        int i = 1;

        while (it.hasNext()) {
            String Nom = (String) it.next();
            System.out.println("livre en position numero " + i + " : " + Nom);
            i++;
        }
    }
}
